import Head from 'next/head'
import Image from 'next/image'
import { useState } from 'react'
import styles from '../styles/Home.module.css'

export default function Home () {
  const [loginPayload, setLoginPayload] = useState({ email: '', password: '' })
  const [authRequestStatus, setAuthRequestStatus] = useState(false)
  const [loginStatus, setLoginStatus] = useState(false)
  const [loginMessage, setLoginMessage] = useState('')

  const handleChange = ({ target }) => {
    setLoginPayload({ ...loginPayload, [target.name]: target.value })
  }

  const handleAuthenticatedRequest = event => {
    event.preventDefault()
    window
      .fetch('/api/hello', {
        method: 'GET'
      })
      .then(response => {
        if (!response.ok) {
          throw new Error('An error occured!')
        }

        // Be sure to return a json from middleware api
        return response.json()
      })
      .then(result => {
        setAuthRequestStatus(true)
      })
      .catch(err => {
        console.error(err.message)
        setAuthRequestStatus(false)
      })
    return false
  }

  const handleSubmit = event => {
    event.preventDefault()
    // We call the middleware API (located in /pages/api).
    // but you can also use the direct call to laravel API here
    // if you want ...
    window
      .fetch('/api/login', {
        method: 'POST',
        body: JSON.stringify(loginPayload)
      })
      .then(response => {
        if (!response.ok) {
          throw new Error('An error occured!')
        }

        // Be sure to return a json from middleware api
        return response.json()
      })
      .then(result => {
        setLoginStatus(true)
        setLoginMessage('Success')
      })
      .catch(err => {
        setLoginMessage('Error: ' + err.message)
      })

    return false
  }

  return (
    <div className={styles.container}>
      <Head>
        <title>Create Next App</title>
        <meta name='description' content='Generated by create next app' />
        <link rel='icon' href='/favicon.ico' />
      </Head>

      <main className={styles.main}>
        <h1 className={styles.title}>
          Welcome to <a href='https://nextjs.org'>Next.js!</a>
        </h1>

        <p className={styles.description}>
          Your login status is{' '}
          <code className={styles.code}>{loginMessage}</code>
        </p>
        <br />

        <form onSubmit={handleSubmit}>
          <input
            onChange={handleChange}
            type='email'
            name='email'
            value={loginPayload.email}
          />
          <input
            onChange={handleChange}
            type='password'
            name='password'
            value={loginPayload.password}
          />
          <nav>
            <input type='submit' value='Login' />
          </nav>
        </form>

        {loginStatus && (
          <>
            <p>You can now perform an authenticated request!</p>
            <nav>
              <button type='button' onClick={handleAuthenticatedRequest}>
                A authenticated request
              </button>
            </nav>
            <p>
              The status is:
              <strong>{authRequestStatus ? 'ok' : 'nok'}</strong>
            </p>
          </>
        )}
      </main>

      <footer className={styles.footer}>
        <a
          href='https://vercel.com?utm_source=create-next-app&utm_medium=default-template&utm_campaign=create-next-app'
          target='_blank'
          rel='noopener noreferrer'
        >
          Powered by{' '}
          <span className={styles.logo}>
            <Image src='/vercel.svg' alt='Vercel Logo' width={72} height={16} />
          </span>
        </a>
      </footer>
    </div>
  )
}
